#include "opencv2/highgui/highgui_c.h"
#include "../../Include/iANPRcapture.h"
#include <stdio.h>
#include <Windows.h>


int main(int argc, char** argv)
{	
	CvCapture* capture = 0;
	if ( argc == 1 ) capture = cvCaptureFromCAM( 0 );
	else capture = cvCaptureFromFile(argv[1]); 
	char buffer[256];
	sprintf( buffer, "out.avi" );
	CvVideoWriter* cvVideoWriter = 0; 		
	ANPR_OPTIONS a;
	a.Detect_Mode = ANPR_DETECTCOMPLEXMODE;
	a.min_plate_size = 500;
	a.max_plate_size = 50000;
	a.max_text_size = 20;		
	a.type_number = ANPR_KAZ_BASE;
	iANPRCapture i_capture;

	IplImage* object = 0;
	IplImage* image = cvCreateImage( cvSize( 800, 600 ), 8, 3 );
	int i = 0;
	char mem[100][20];
	int all_mem = 0;
	for(;;)
    {		
		IplImage* frame = 0;    
		frame = cvQueryFrame(capture );
		if( !frame )
            break;

		if (!object)
		{
			object = cvCreateImage(cvGetSize(frame), 8, 1);			
			cvZero( object );
            object->origin = frame->origin;			
			i_capture = CreateiANPRCapture( 10, a, cvRect( 0, 0, frame->width, frame->height ) );
		}
		cvCvtColor( frame, object, CV_BGR2GRAY );		

		DWORD tick1 = GetTickCount();		
		int i1 = 0;
		CvRect Rects[100];
		int all = 100;
		char** res = new char*[all];
		for(int j=0;j<all;j++) res[j] = new char[20];

		i1 = AddFrameToiANPRCapture( i_capture, object, &all, Rects, res );
		DWORD tick2 = GetTickCount();
		printf( "Num:%d; time:%5.3f; cand:%d  ", i, (float) ( tick2 - tick1) / 1000, all );
		if ( i1 == 0 )
		{						
			for(int j = 0; j < all; j++ )				
			{				
				if ( strlen( res[j] ) >= 6 )
				{
					int k =0;
					for( int j1 = 0; j1 < all_mem; j1++ )
						if ( strcmp( res[j], mem[j1]) == 0 ) k = 1;	//      ,    
					if ( k == 0 ) continue;
					cvRectangle( frame,cvPoint( Rects[j].x, Rects[j].y),cvPoint(Rects[j].x+Rects[j].width,
						Rects[j].y+Rects[j].height), CV_RGB(255,255,0), 2);
					
					CvFont font;
					float aa=0.001f*frame->width;
					cvInitFont( &font, CV_FONT_HERSHEY_SIMPLEX, aa,
									aa,0,1, 8 ); 
					CvPoint pp2,pp1;
					pp2.x=Rects[j].x;
					pp2.y=Rects[j].y;
					pp1.x=Rects[j].x+1;
					pp1.y=Rects[j].y+1;
					cvPutText( frame, res[j], pp1, &font, CV_RGB(0,0,0) );
					cvPutText( frame, res[j], pp2, &font, CV_RGB(0,255,0) );
					printf( "%s;", res[j] );
				}			
			}
			//   
			for(int j = 0; j < all; j++ )				
			{
				for( i1 = 0; i1 < strlen( res[j] ); i1++ )
					if ( res[j][i1] == '?' ) {
						i1 = -1;
						break;
					}
				if ( i1 == -1 ) continue;
				if ( strlen( res[j] ) >= 6 )
				{
					strcpy( mem[j], res[j] );
				}
			}
			all_mem = all;
		}			
		printf( "\n" );
		for(int j=0;j<100;j++) delete [] res[j];
		delete [] res;
		i++;
		cvResize( frame, image );
		cvShowImage( "frame", image);
		/*if (!cvVideoWriter)
		{
				cvVideoWriter=cvCreateVideoWriter( buffer, CV_FOURCC('D', 'I', 'V', '3'), 30,
						cvGetSize( frame) );
		}	
		cvWriteFrame( cvVideoWriter, frame );*/

		int c = cvWaitKey( 20 );
		if ( c == 32 )
			c = cvWaitKey( 0 ); // pause
		if ( c== 27 ) break;
	}

	cvReleaseCapture( &capture );
	//cvReleaseVideoWriter( &cvVideoWriter );
	if ( i_capture != NULL ) ReleaseiANPRCapture( &i_capture );

	return 0;
}