#include "opencv2/highgui/highgui_c.h"
#include "../../Include/iANPR.h"
#include <stdio.h>
#include <Windows.h>
#include <omp.h>

int main( int argc, char** argv)
{
	if ( argc > 1 )
	{
		IplImage* Img = cvLoadImage( argv[1], CV_LOAD_IMAGE_GRAYSCALE  );
		if ( Img == NULL ){
			printf( "Cann't load file!");
			return 1;
		}		
		{
			// 
			CvRect Rects[100];
			int all = 100;
			char** res = new char*[all];
			for(int j=0;j<all;j++) res[j] = new char[20];
			ANPR_OPTIONS a;
			a.Detect_Mode = ANPR_DETECTCOMPLEXMODE;
			a.min_plate_size = 500;
			a.max_plate_size = 50000;
			a.max_text_size = 20;		
			a.type_number = ANPR_KAZ_BASE;		
			a.flags = 0;
			int i;		
			DWORD tick1 = GetTickCount();
			i = anprPlate( Img,  a, &all, Rects, res ); 
			DWORD tick2 = GetTickCount();			
			if ( i == 0 )
				for( int j = 0; j < all; j++ ) {				
					printf( "%s\n", res[j] );
				}
			printf( "Time:%5.3f;\n", (float) ( tick2 - tick1) / 1000 );

			for(int j=0;j<100;j++) delete [] res[j];
			delete [] res;		
		}

		// 
		int add_size = 40; //  40    , 80 -   

		int max = omp_get_num_procs();	
		IplImage** Images = new IplImage*[max];
		int i;

		DWORD tick1 = GetTickCount();

		for( i = 0; i < max; i++ )
		{
			int k = add_size, h = 0;
			if ( i != 0 && i != max - 1 ) {
				k += add_size;
				h = add_size;
			}
			if ( i == max - 1 ) h = add_size;
			Images[i] = cvCreateImage( cvSize( Img->width, k + Img->height / max ), 8, 1 );
			cvSetImageROI( Img, cvRect( 0, i * int(Img->height / max) - h, Img->width, Img->height / max + k ) );
			cvCopy( Img, Images[i] );
			cvResetImageROI( Img );
		}

#pragma omp parallel
		{
#pragma omp for
			for( i = 0; i < max; i++ )
			{
				CvRect Rects[100];
				int all = 100;
				char** res = new char*[all];
				for(int j=0;j<all;j++) res[j] = new char[20];
				ANPR_OPTIONS a;
				a.Detect_Mode = ANPR_DETECTCOMPLEXMODE;
				a.min_plate_size = 500;
				a.max_plate_size = 50000;
				a.max_text_size = 20;		
				a.type_number = ANPR_RUSSIAN_BASE;		
				a.flags = 0;

				int i2 = anprPlate( Images[i],  a, &all, Rects, res ); 
				if ( i2 == 0 )
					for( int j = 0; j < all; j++ ) {				
#pragma omp critical
						{
							printf( "%s\n", res[j] );
						}
					}

				for(int j=0;j<100;j++) delete [] res[j];
				delete [] res;		
			}
		}
		DWORD tick2 = GetTickCount();
		printf( "Time:%5.3f;\n", (float) ( tick2 - tick1) / 1000 );

		for( i = 0; i < max; i++ )
			cvReleaseImage ( &Images[i] );
		delete [] Images;
		
		cvReleaseImage ( &Img );
	}
	return 0;
}